#region Copyright

/*
 * Copyright 2005-2007 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */

#endregion

using System;
using System.Collections;
using System.Collections.Generic;

namespace Seasar.Dxo.Converter.Impl
{
    /// <summary>
    /// IuWFNgT[]ȔzɕϊRo[^NX
    /// </summary>
    public class ArrayConverter<T> : AbstractPropertyConverter
    {
        /// <summary>
        /// IuWFNg̃vpeBCӂ̌^ɕϊ܂
        /// (ۃ\bh͔hNXŕKI[oCh܂)
        /// </summary>
        /// <param name="source">ϊ̃IuWFNg</param>
        /// <param name="dest">ϊ̃IuWFNg</param>
        /// <param name="expectType">ϊ̃IuWFNgɊ҂Ă^</param>
        /// <returns>bool ϊꍇɂtrue</returns>
        protected override bool DoConvert(object source, ref object dest, Type expectType)
        {
            if (dest == null)
            {
                //z^́AnullZbgĂ邱Ƃ̂ŃCX^X𐶐Ă
                dest = new T[0];
            }
            T[] result = (dest as T[]);
            if (result != null)
                Array.Clear(result, 0, result.Length);
            else
                throw new ArgumentNullException("dest");

            if (source is ICollection<T>)
            {
                ICollection<T> sourceCollection = source as ICollection<T>;
                //zReNew
                if (sourceCollection.Count > result.Length)
                {
                    result = new T[sourceCollection.Count];
                    dest = result; //z蒼̂œ]LKv
                }
                //WFlbNڃRs[ł
                sourceCollection.CopyTo(result, 0);
                return true;
            }
                //RNVΏ
            else if (source is ICollection)
            {
                ICollection sourceCollection = source as ICollection;
                //zReNew
                if (sourceCollection.Count > result.Length)
                {
                    result = new T[sourceCollection.Count];
                    dest = result; //z蒼̂œ]LKv
                }
                if (source.GetType().IsArray)
                {
                    if (source is T[])
                    {
                        //^v̔zȂΒڃRs[ł
                        (source as T[]).CopyTo(result, 0);
                        return true;
                    }
                    else
                    {
                        //vf̌^Ɍ݊邩ׂĂoNRs[
                        Type elementType = source.GetType().GetElementType();
                        if (typeof (T).IsAssignableFrom(elementType))
                        {
                            if (source is Array)
                            {
                                (source as Array).CopyTo(result, 0);
                                return true;
                            }
                            else
                            {
                                return false;
                            }
                        }
                    }
                }
                else
                {
                    //weWjAXȃRNV̏ꍇl1ACeɌ^`FbNKv
                    int i = 0;
                    foreach (object item in sourceCollection)
                    {
                        //vf̌^Ɍ݊邩ׂăRs[
                        if (item.GetType().IsAssignableFrom(typeof (T)))
                        {
                            result.SetValue(item, i);
                            i++;
                        }
                        else
                        {
                            return false;
                        }
                    }
                    return true;
                }
            }
            return false;
        }
    }
}